import React, { useState } from 'react';

import { useDB } from 'react-pouchdb';

import GPX from '../../lib/gpx-parser-builder';

import '../../theme/get-location.css';
import { IonButton, IonIcon, IonItem } from '@ionic/react';
import { recordingOutline, recording } from 'ionicons/icons';
import { pushTrack } from '../../db/tracks';
import {
  startBackgroundGeolocation,
  stopBackgroundGeolocation,
} from '../../lib/background-geolocation';

const GpxRecord: React.FC<{}> = () => {
  const db = useDB();

  const [isRecording, setIsRecording] = useState(false);

  const [watcher_id, setWatcher_id] = useState();

  const toggleIsRecording = () => {
    if (isRecording) {
      stopBackgroundGeolocation(watcher_id);
    } else {
      startBackgroundGeolocation(db).then((result) => {
        setWatcher_id(result);
      });
    }
    setIsRecording(!isRecording);
  };

  return (
    <IonButton onClick={toggleIsRecording}>
      {isRecording && (
        <IonIcon slot='icon-only' icon={recording} style={{ color: 'red' }} />
      )}
      {!isRecording && <IonIcon slot='icon-only' icon={recordingOutline} />}
    </IonButton>
  );
};

export default GpxRecord;
