import react from 'react';

import MouseHandler from './mouse-handler';
import SingleTouchHandler from './single-touch-handler';
import DoubleTouchHandler from './double-touch-handler';
import WheelHandler from './wheel-handler';
import { useSelector } from 'react-redux';
import { MapState } from '../../store/map';

import '../../theme/slippy.css';

interface SlippyProps {
  children?: any;
}

const Slippy: react.FC<SlippyProps> = (props: SlippyProps) => {
  //console.log(`--- Rendering viewport, props: ${JSON.stringify(props)} ---`);

  const slippyState = useSelector(
    (state: { map: MapState }) => state.map.slippy
  );

  console.log(`slippyState: ${JSON.stringify(slippyState)}`);

  return (
    <div className='slippy'>
      <MouseHandler>
        <SingleTouchHandler>
          <DoubleTouchHandler>
            <WheelHandler>
                 {props.children}
            </WheelHandler>
          </DoubleTouchHandler>
        </SingleTouchHandler>
      </MouseHandler>
    </div>
  );
};

export default Slippy;
